import { GArray, PropertyHint, Resource, Variant } from 'godot'
import SaveState from './save_state'
import ProgressState from './progress_state'
import { export_, export_array, export_object } from 'godot.annotations'

export default class GameState extends Resource {
  //@export_object(ProgressState)
  //progress: ProgressState = new ProgressState()

  @export_(Variant.Type.TYPE_ARRAY, { class_: SaveState, hint: PropertyHint.PROPERTY_HINT_RESOURCE_TYPE })
  world: SaveState[] = []
}

export interface Savable {
  on_save_game(save_data: GameState): void
  on_before_load_game?(): void
  on_load_game<T extends SaveState>(state: T): void
}

